<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="商品名称" prop="spuName">
        <el-input v-model="queryParams.spuName" placeholder="请输入商品名称" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-input v-model="queryParams.status" placeholder="状态" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['system:goods:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['system:goods:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['system:goods:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <PutShopOffShop ref="putShopOffShop" @callback="getList" />
    <el-table v-loading="loading" :data="spuList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="商品名称" align="center" prop="name" width="150" />
      <el-table-column label="编码" align="center" prop="code" width="150" />
      <el-table-column label="折扣价" align="center" prop="discount" width="150" />
      <el-table-column label="原价" align="center" prop="price" width="150" />
      <el-table-column label="销售总量" align="center" prop="salesVolume" width="150" />
      <el-table-column label="简介" align="center" prop="desc" />
      <el-table-column label="备注" align="center" prop="remarks" width="150" />
      <!-- <el-table-column
        label="上架时间"
        align="center"
        prop="shelfTime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.shelfTime, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column> -->
      <el-table-column label="状态" align="center" prop="state" width="150">
        <template slot-scope="scope">
          <span v-if="scope.row.state == 1">已创建</span>
          <span v-if="scope.row.state == 2">已完成编程</span>
          <span v-if="scope.row.state == 3">已上架</span>
          <span v-if="scope.row.state == 4">已下架</span>
          <span v-if="scope.row.state == 5">已删除</span>

        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" width="250" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['system:goods:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-if="authBtn(['1', '2', '3', '4'], scope.row.state)">删除</el-button>
          <el-button size="mini" type="text" v-if="authBtn(['2', '4'], scope.row.state)"
            @click="putShopOffShop(scope.row.id, true)">上架</el-button>
          <el-button size="mini" type="text" v-if="authBtn(['3'], scope.row.state)"
            @click="putShopOffShop(scope.row.id)">下架</el-button>
          <el-button size="mini" type="text" v-if="authBtn(['5'], scope.row.state)" @click="restGoods(scope.row)">恢复
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />
    <Form ref="Form" />
  </div>
</template>

<script>
import { listSpu, delSpu, updateSpu } from "@/api/system/goods";
import PutShopOffShop from './components/putShopOffShop.vue'
import Form from "./components/Form.vue";
export default {
  name: "Spu",
  components: { Form, PutShopOffShop },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      spuList: [],
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        spuName: null,
        productionTime: null,
        discountPrice: null,
        originalPrice: null,
        label: null,
        desc: null,
        createUserId: null,
        updateUserId: null,
        shelfTime: null,
        status: null,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      listSpu(this.queryParams).then((response) => {
        this.spuList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },

    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$refs.Form.handleAdd();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$refs.Form.handleUpdate(row.id);
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除编号为"' + ids + '"的数据项？')
        .then(function () {
          return delSpu(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "system/goods/export",
        {
          ...this.queryParams,
        },
        `spu_${new Date().getTime()}.xlsx`
      );
    },
    putShopOffShop(id, type) {
      if (type == 1) {
        this.$refs.putShopOffShop.putShopModal(id)
        return
      }
      this.$refs.putShopOffShop.offShopModal(id)


    },
    restGoods(data) {
      updateSpu({ ...data, isDeleted: 0, state: 2 }).then(res => {
        this.$modal.msgSuccess("恢复成功");
        this.getList()

      })
    }
  },
};
</script>
